#include "ScreenManager.h"

// global window variables
struct _sm_WindowArea *sm_WindowArea;
struct _sm_Window     *sm_CurrentWindow;

long sm_IsInitialized;

long sm_WindowAreaSize;

// prefs
long sm_TitlebarHeight;

// global mouse variables
struct _sm_Cursor *sm_CurrentMouseCursor;
struct _sm_Cursor *sm_DesktopMouseCursor;

long sm_ExamineMouse;
long sm_MouseX;
long sm_MouseY;

// global mouse variables: left button
long mBtn_down_left;
long mBtn_mode_left;
long mBtn_mode_left_args[6];

// global mouse variables: right button
long mBtn_down_right;



// System Colors
//struct _sm_ColorManager sm_SysColors;
long sm_SysColors[ sizeof(struct _sm_ColorManager)/4 ];


// internal mouse cursors
#define blk 0x080808
#define wht 0xFFFFFF

struct _sm_Cursor *MouseCursor_1;  // standard cursor (normal arrow)
long MouseCursor_1_Data[ 4 + 12*21 ] =
{
    12, 21,     // width & height
     0,  0,     // offX  & offY
   
   blk, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,blk, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,wht,blk, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,wht,wht,blk, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,wht,wht,wht,blk, 0 , 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,wht,wht,wht,wht,blk, 0 , 0 , 0 , 0 , 0 , 0 ,
   blk,wht,wht,wht,wht,wht,blk, 0 , 0 , 0 , 0 , 0 ,
   blk,wht,wht,wht,wht,wht,wht,blk, 0 , 0 , 0 , 0 ,
   blk,wht,wht,wht,wht,wht,wht,wht,blk, 0 , 0 , 0 ,
   blk,wht,wht,wht,wht,wht,wht,wht,wht,blk, 0 , 0 ,
   blk,wht,wht,wht,wht,wht,wht,wht,wht,wht,blk, 0 ,
   blk,wht,wht,wht,wht,wht,wht,blk,blk,blk,blk,blk,
   blk,wht,wht,wht,blk,wht,wht,blk, 0 , 0 , 0 , 0 ,
   blk,wht,wht,blk,blk,wht,wht,blk, 0 , 0 , 0 , 0 ,
   blk,wht,blk, 0 , 0 ,blk,wht,wht,blk, 0 , 0 , 0 ,
   blk,blk, 0 , 0 , 0 ,blk,wht,wht,blk, 0 , 0 , 0 ,
   blk, 0 , 0 , 0 , 0 , 0 ,blk,wht,wht,blk, 0 , 0 ,
    0 , 0 , 0 , 0 , 0 , 0 ,blk,wht,wht,blk, 0 , 0 ,
    0 , 0 , 0 , 0 , 0 , 0 , 0 ,blk,wht,wht,blk, 0 ,
    0 , 0 , 0 , 0 , 0 , 0 , 0 ,blk,wht,wht,blk, 0 ,
    0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,blk,blk, 0 , 0
};



struct _sm_Cursor *MouseCursor_2;  // size cursor west-east
long MouseCursor_2_Data[ 4 + 21*9 ] =
{
    21,  9,     // width & height
    11,  5,     // offX  & offY
                           
    0 , 0 , 0 , 0 ,wht,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,wht, 0 , 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 ,wht,blk,blk,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,blk,blk,wht, 0 , 0 ,
    0 ,wht,blk,blk,blk,wht,wht,wht,wht,wht,wht,wht,wht,wht,wht,wht,blk,blk,blk,wht, 0 ,
   wht,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,blk,wht,
    0 ,wht,blk,blk,blk,wht,wht,wht,wht,wht,wht,wht,wht,wht,wht,wht,blk,blk,blk,wht, 0 ,
    0 , 0 ,wht,blk,blk,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,blk,blk,wht, 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 , 0 ,wht,wht, 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ,wht,wht, 0 , 0 , 0 , 0
};



struct _sm_Cursor *MouseCursor_3;  // size cursor north-south
long MouseCursor_3_Data[ 4 + 9*21 ] =
{
     9, 21,     // width & height
     5, 11,     // offX  & offY
                           
    0 , 0 , 0 , 0 ,wht, 0 , 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 ,wht,blk,blk,blk,wht, 0 , 0 ,
    0 ,wht,blk,blk,blk,blk,blk,wht, 0 ,
   wht,blk,blk,blk,blk,blk,blk,blk,wht,
   wht,wht,wht,wht,blk,wht,wht,wht,wht,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
   wht,wht,wht,wht,blk,wht,wht,wht,wht,
   wht,blk,blk,blk,blk,blk,blk,blk,wht,
    0 ,wht,blk,blk,blk,blk,blk,wht, 0 ,
    0 , 0 ,wht,blk,blk,blk,wht, 0 , 0 ,
    0 , 0 , 0 ,wht,blk,wht, 0 , 0 , 0 ,
    0 , 0 , 0 , 0 ,wht, 0 , 0 , 0 , 0
};




