#define And &&
#define Or  ||

//#define ulong unsigned long
//#define DWORD 
#define  smWORD unsigned int
#define  smBYTE unsigned char

#define smRGB(r, g ,b)  ((long) (((unsigned char) (r) | ((unsigned int) (g)  << 8)) | (((unsigned long) (unsigned char) (b)) << 16))) 
#define smRed(rgb)      ((smBYTE)(rgb))
#define smGreen(rgb)    ((smBYTE)(((smWORD)(rgb)) >> 8))
#define smBlue(rgb)     ((smBYTE)((rgb)>>16))

// Window Flags
#define SM_Window_MinimizeGadget  (long)(1<< 0) // Adds the minimize gadget to the window title bar. #PB_Window_System is automatically added. 
#define SM_Window_MaximizeGadget  (long)(1<< 1) // Adds the maximize gadget to the window title bar. #PB_Window_System is automatically added. 
#define SM_Window_Sizeable        (long)(1<< 2) // Adds the sizeable feature to a window. 
#define SM_Window_Invisible       (long)(1<< 3) // Creates the window but don't display. Not supported on AmigaOS. 
#define SM_Window_Titlebar        (long)(1<< 4) // Creates a window with a titlebar. 
#define SM_Window_Borderless      (long)(1<< 5) // Creates a window without any borders. 
//#define SM_Window_ScreenCentered  (1<< 6) // Centers the window in the middle of the screen. x,y parameters are ignored. 
//#define SM_Window_WindowCentered  (1<< 7) // Centers the window in the middle of the parent window. x,y parameters are ignored. 

// Window Messages
#define SMM_PAINT                 1
#define SMM_CLOSE                 2



// Color Manager Indexes
enum sm_ColorManager_Indexes
{
  color_window,
  color_window_text,

  color_titlebar_active1,
  color_titlebar_active2,
  color_titlebar_inactive1,
  color_titlebar_inactive2,
  color_titlebar_text_active,
  color_titlebar_text_inactive,

  color_3D_shadow1,
  color_3D_shadow2,
  color_3D_shadow3,
  color_3D_shadow4,

  color_child,
  color_child_alternate,
  color_child_selected,
  color_child_highlight,
  
  color_child_text,
  color_child_text_selected,

  color_btn,
  color_btn_text,
  color_btn_highlight,

  color_menu1,
  color_menu2,
  color_menu_highlight,
  color_menu_text,
  color_menu_text_highlight,
  color_menu_text_disabled,

  color_tooltip,
  color_tooltip_text,
  color_tooltip_border
};


struct _sm_Window;
struct _sm_WindowArea;
//typedef int (_stdcall *WindowProc)(struct sm_Window,int Msg, long wParam, long lParam); 

struct _sm_Rect
{
  long x;
  long y;
  long width;
  long height;
};

struct _sm_ColorManager
{
  long color_window;
  long color_window_text;

  long color_titlebar_active1;
  long color_titlebar_active2;
  long color_titlebar_inactive1;
  long color_titlebar_inactive2;
  long color_titlebar_text_active;
  long color_titlebar_text_inactive;

  long color_3D_shadow1;
  long color_3D_shadow2;
  long color_3D_shadow3;
  long color_3D_shadow4;

  long color_child;
  long color_child_alternate;
  long color_child_selected;
  long color_child_highlight;
  
  long color_child_text;
  long color_child_text_selected;

  long color_btn;
  long color_btn_text;
  long color_btn_highlight;

  long color_menu1;
  long color_menu2;
  long color_menu_highlight;
  long color_menu_text;
  long color_menu_text_highlight;
  long color_menu_text_disabled;

  long color_tooltip;
  long color_tooltip_text;
  long color_tooltip_border;
};


struct _sm_Cursor
{
	long sprite;
	
	long width;
	long height;
	
	long offX;
	long offY;
};


struct _sm_Window
{
  struct _sm_Rect rect_maximized;
  struct _sm_Rect rect;
  long            client_width;
  long            client_height;
  long            sprite;
  long            icon;
  long            cursor;
  char            *title;

  struct _sm_ColorManager *ColorManager;
  struct _sm_WindowArea   *ChildWindows;
  struct _sm_Window       *Parent;

  long (_stdcall *WinProc) (struct _sm_Window *this,long Msg, long wParam, long lParam);

  long WindowData[10];
  long UserData[10];

  // Window Flags
  unsigned hidden       : 1;
  unsigned border       : 1;
  unsigned titlebar     : 2;
  unsigned sizeable     : 1;
  unsigned moveable     : 1;
  unsigned btn_maximize : 1;
  unsigned btn_minimize : 1;
  unsigned btn_close    : 1;
  unsigned btn_help     : 1;

  unsigned state_maximized : 1;
  unsigned state_minimized : 1;
};


struct _sm_WindowArea
{
  struct _sm_Window *win[];
};



extern struct _sm_WindowArea   *sm_WindowArea;
extern struct _sm_Window       *sm_CurrentWindow;
extern long                     sm_SysColors[ sizeof(struct _sm_ColorManager)/4 ];

extern long sm_IsInitialized;

extern long sm_WindowAreaSize;

extern long sm_TitlebarHeight;


extern struct _sm_Cursor *sm_CurrentMouseCursor;
extern struct _sm_Cursor *sm_DesktopMouseCursor;

extern long sm_ExamineMouse;
extern long sm_MouseX;
extern long sm_MouseY;

extern long mBtn_down_left;
extern long mBtn_down_right;

long mBtn_mode_left;
long mBtn_mode_left_args[6];

extern struct _sm_Cursor *MouseCursor_1;  // standard cursor (normal arrow)
extern struct _sm_Cursor *MouseCursor_2;  // size cursor west-east
extern struct _sm_Cursor *MouseCursor_3;  // size cursor north-south

extern long MouseCursor_1_Data[ 4 + 12*21 ];
extern long MouseCursor_2_Data[ 4 + 21* 9 ];
extern long MouseCursor_3_Data[ 4 +  9*21 ];


// internal Sub-Functions
extern _stdcall void  sub_smInitialize(void);
extern _stdcall void  sub_smMouseManager(void);
extern _stdcall void  sub_smMouseDisplay(void);
extern _stdcall void  sub_smMouseBtnDownLeft(struct _sm_Window *window, long MouseX, long MouseY);
extern _stdcall void  sub_smCreateSysMouseCursors(void);
extern _stdcall long  sub_smDrawCaptionAndBorder(struct _sm_Window *window, long state);
extern _stdcall long  sub_smDrawGradient(long x, long y, long width, long height, long color1, long color2);
extern _stdcall long  sub_smMouseCheckAgainstWindowBorder(struct _sm_Window *window, long MouseX, long MouseY);

extern _stdcall struct _sm_Window* sub_smCreateWindow(long x, long y, long width, long height, char *text, struct _sm_Window *Parent, long (_stdcall *WinProc) (struct _sm_Window *this,long Msg, long wParam, long lParam));
extern _stdcall struct _sm_Window* sub_smFindWindowByMouseXY(long x, long y);

// Sub-Functions also used by PB
extern _stdcall struct _sm_Window* PB_smActivateWindow(struct _sm_Window*);

extern _stdcall long* PB_smGetDefaultSysColors(void);
extern _stdcall long  PB_smSetSysColors(long *colors);
extern _stdcall long  PB_smGetWindowColor(struct _sm_Window *window, long color_index);

extern _stdcall struct _sm_Cursor* PB_smCatchMouseCursor(long *data);




