
#include "..\ScreenManager.h"
#include "..\PB_Functions.h"


extern _stdcall long sub_smMouseCheckAgainstWindowBorder(struct _sm_Window *window, long MouseX, long MouseY)
{
  //
  // check mouse co-ordinates against window border
  //
  // returns:   0 = not on border
  //
  //            1 = top
  //            2 = right
  //            3 = bottom
  //            4 = left
  //
  //           11 = sizeable border, top
  //           12 = sizeable border, right
  //           13 = sizeable border, bottom
  //           14 = sizeable border, left
  //
  if (window)
	{
	  if (window->border Or window->sizeable)
		{
		  long offsetX  = 2;
		  long offsetY  = 2;
		  long sizeable = window->sizeable * 10;
		  
		  // left border
		  if      ( MouseX < (window->rect.x + offsetX) )
			{
			  if (sizeable) sm_CurrentMouseCursor = MouseCursor_2;
			  return 4 + sizeable;
			}
		  // right border
		  else if ( MouseX > (window->rect.x + window->rect.width - offsetX) )
			{
			  if (sizeable) sm_CurrentMouseCursor = MouseCursor_2;
			  return 2 + sizeable;
			}
		  // top border
		  else if ( MouseY < (window->rect.y + offsetY) )
			{
        if (sizeable) sm_CurrentMouseCursor = MouseCursor_3;
			  return 1 + sizeable;
			}
		  // bottom border
		  else if ( MouseY > (window->rect.y + window->rect.height - offsetY) )
			{
			  if (sizeable) sm_CurrentMouseCursor = MouseCursor_3;
			  return 3 + sizeable;
			}
		}
  }
 
 // mouse cursor not on border
 return 0;
}



