
#include "..\ScreenManager.h"
#include "..\PB_Functions.h"
#include <windows.h>


extern _stdcall void sub_smMouseManager(void)
{
   // Mouse Manager
   //
   if (sm_ExamineMouse = PB_ExamineMouse())
     {
       long mBtn_left, mBtn_right, mWheel;
       struct _sm_Window *window;
			 struct _sm_Window *window_under_cursor;

       sm_MouseX = PB_MouseX();
       sm_MouseY = PB_MouseY();

       mBtn_left  = PB_MouseButton(1);
			 mBtn_right = PB_MouseButton(2);
			 mWheel     = PB_MouseWheel();
			 
			 window_under_cursor = sub_smFindWindowByMouseXY(sm_MouseX,sm_MouseY);
			 
       // Check Mouse Button: LEFT
       if ((mBtn_left!=0) And (mBtn_right==0)) // mouse button pressed: left
         {
           if (mBtn_down_left) // still down: left
             {
               if (mBtn_mode_left==1)
               {
                 window = sm_CurrentWindow;
                 if (window)
                     {
                       window->rect.x = sm_MouseX - mBtn_mode_left_args[0];
                       window->rect.y = sm_MouseY - mBtn_mode_left_args[1];
                     }
               }
             }
           else                // new down: left
             {
               mBtn_down_left = 1;
               
               window = window_under_cursor;
               if (window) // window under cursor
                 {
                   if ( window == sm_CurrentWindow )
                     {
                       sub_smMouseBtnDownLeft(window, sm_MouseX, sm_MouseY);
                     }
                   else
                     {
                       // activate new window and bring it to foreground
                       if ( window = PB_smActivateWindow( window ) )
                         {
                           sub_smMouseBtnDownLeft(window, sm_MouseX, sm_MouseY);
                         }
                     }
                 }
               else        // no window under cursor
                 {
                   if (sm_CurrentWindow)
                   {
                     // de-activate old window, activate desktop
                     PB_smActivateWindow(0);
                   }
                 }
               
             }
         }
       else                                // mouse button NOT pressed: left
         {
           if (mBtn_down_left) // was down, now released: left
             {
               mBtn_mode_left = 0;
               mBtn_down_left = 0;
							 sm_CurrentMouseCursor = MouseCursor_1;

               //Beep(800,100);
             }
         }
       

       // Check Mouse Button: RIGHT
       if ((mBtn_right!=0) And (mBtn_left==0)) // mouse button pressed: right
         {
           if (mBtn_down_right) // still down: right
             {
             }
           else                 // new down: right
             {
               mBtn_down_right = 1;
               //Beep(1000,10);
             }
         }
       else                                // mouse button NOT pressed: right
         {
           if (mBtn_down_right) // was down, now released: right
             {
               mBtn_down_right = 0;
               //Beep(1000,100);
             }
         }
       

       // Check Mouse WHEEL
       if (mWheel)
         {
           if (mWheel>0)
             {
               // mouse wheel up
               for (long i=0;i<mWheel;i++)
               {
                 Beep(800,50);
               }
             }
           else
             {
               // mouse wheel down
               for (long i=0;i<-(mWheel);i++)
               {
                 Beep(1000,50);
               }
             }
         }
			 
			 // no button pressed atm
			 if ( (!mBtn_down_left) And (!mBtn_down_right) )
				 {
				   if (window_under_cursor)
						 {
  						 // check window under cursor
						   sm_CurrentMouseCursor = MouseCursor_1;
						   
						   if (sub_smMouseCheckAgainstWindowBorder(window_under_cursor,sm_MouseX,sm_MouseY)==0)
								 {
								   // cursor not on border, check titlebar
								 }
						 }
					 else
						 {
						   // desktop under cursor
  						 sm_CurrentMouseCursor = sm_DesktopMouseCursor;
						 }
				 }
       
     }
}



